<?php

/* Appora server
 * Copyright (C) 2011 Appora contributors
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

require_once($_MODELS_DIR . "/Branch.php");
require_once($_MODELS_DIR . "/Version.php");
require_once(dirname(__FILE__)."/VersionJSONDTO.php");

class BranchJSONDTO {

	private function __construct() {
	}
	
	public function toJSON($branch) {
		$json = '{"id":' . $branch->getIdentifier() . ',';
		$name = json_encode(utf8_encode($branch->getName()));
		$json .= '"name":' . $name . ',';
		$json .= '"versions":[';
		$bFirstElement = true;
		foreach ($branch->getVersions() as $version) {
			if ($bFirstElement) {
				$bFirstElement = false;
			} else {
				$json .= ",";
			}
			$json .= VersionJSONDTO::toJSON($version);
		}
		$json .= ']}';
		return $json;
	}
}

?>